// 创建本地推送消息
function createLocalPushMsg(content, payload, options) {
	// 创建本地推送消息
	plus.push.createMessage(content, payload, options);
	// 创建本地推送消息回调
	console.log("创建本地消息成功，请到系统消息中心查看。");
};

// 推送事件监听
// 个推透传消息格式符合：{ title: "通知标题", content: "通知主题", payload: " { "type": "JsonMSG", "eval": "自定义推送事件" } " }
// Android 识别为离线推送消息（APP 在线或离线时，服务器推送的消息均会进入系统消息中心）,否则识别为在线透传消息并触发receive事件
// iOS 识别为在线APNS消息并触发receive事件（APP 在线时，服务器推送的消息不会进入系统消息中心；APP 离线时，服务器推送的消息会进入系统消息中心）
function onPush() {
	// 监听推送消息
	plus.push.addEventListener("click", function(msg) {
		if(msg.payload) {
			// 格式化推送消息数据
			var payload = JSON.parse(msg.payload);
			// 判断本地/离线推送类型
			if(payload.type == "LocalMSG") {
				console.log("本地推送消息\n" + "标题：" + msg.title + "\n主题：" + msg.content + "\nJSON数据：" + msg.payload);
			} else {
				console.log("离线推送消息\n" + "标题：" + msg.title + "\n主题：" + msg.content + "\nJSON数据：" + msg.payload);
			};
		} else {
			console.log("payload: undefined");
		};
	}, false);
	// 监听在线消息
	plus.push.addEventListener("receive", function(msg) {
		if(msg.aps) {
			// Apple APNS message
			console.log("在线APNS消息：" + msg.aps + "JSON数据：" + JSON.parse(msg.aps));
		} else {
			console.log("在线透传消息：" + msg.payload + "JSON数据：" + msg.payload);
		};
	}, false);
};

// 首次启动应用推送消息
function createlLoaclTest(info) {
	var content = dateToStr(new Date()) + " 欢迎来至" + info + "的朋友";
	var payload = '{"type": "LocalMSG"}';
	var options = {
		"title": "温馨提示",
		"icon": "_www/images/iconPush.png",
		"sound": "system",
		"cover": false
	};
	createLocalPushMsg(content, payload, options);
};

// 格式化日期时间字符串，格式为"YYYY-MM-DD HH:MM:SS"
function dateToStr(d) {
	return(d.getFullYear() + "-" + ultZeroize(d.getMonth() + 1) + "-" + ultZeroize(d.getDate()) + " " + ultZeroize(d.getHours()) + ":" + ultZeroize(d.getMinutes()) + ":" + ultZeroize(d.getSeconds()));
};

function ultZeroize(v, l) {
	var z = "";
	l = l || 2;
	v = String(v);
	for(var i = 0; i < l - v.length; i++) {
		z += "0";
	}
	return z + v;
};