// 定义本地应用资源版本号
var wgtVer = null,
	newVer = null;
// 定义检查更新服务器地址
var checkUrl = "http://www.i4nova.com/app-update/sjcy/version.php";

function checkVersion() {
	// 获取本地应用资源版本号
	plus.runtime.getProperty(plus.runtime.appid, function(inf) {
		wgtVer = inf.version;
		console.log("当前应用版本：" + wgtVer);
	});
	setTimeout(
		function() {
			checkUpdate();
		}, 1000
	);
};

// 检测更新	
function checkUpdate() {
	var xhr = new XMLHttpRequest();
	xhr.onreadystatechange = function() {
		switch(xhr.readyState) {
			case 4:
				plus.nativeUI.closeWaiting();
				if(xhr.status == 200) {
					console.log("检测更新成功！：" + xhr.responseText);
					newVer = xhr.responseText;
					if(wgtVer && newVer && (wgtVer < newVer)) {
						// 创建本地推送消息
						var content = "发现私家茶园有新版本(V " + newVer + ")，请及时更新！";
						var payload = '{"type": "LocalMSG"}';
						var options = {
							"title": "发现新版本",
							"icon": "_www/images/iconPush.png",
							"sound": "system",
							"cover": false
						};
						// 推送消息
						createLocalPushMsg(content, payload, options);
						// 提示消息
						plus.nativeUI.toast("发现新版本", {
							"duration": "long"
						});
						// 弹出系统确认对话框
						downConfirm();
					} else {
						// 提示消息
						plus.nativeUI.toast("已是最新版本", {
							"duration": "long"
						});
					};
				} else {
					console.log("检测更新失败");
				};
				break;
			default:
				break;
		}
	}
	xhr.open("GET", checkUrl);
	xhr.send();
};

// 弹出系统确认对话框
function downConfirm() {
	plus.nativeUI.confirm("发现私家茶园有新版本(V" + newVer + ")，立即下载更新？", function(event) {
		if(event.index == 0) {
			// 下载wgt文件
			downWgt();
			// 清空所有推送消息
			plus.push.clear();
		} else {
			plus.nativeUI.toast("等待下次启动检查更新", {
				"duration": "long"
			});
		};
	}, {
		"title": "提示",
		"buttons": ["确定", "取消"],
		"verticalAlign": "center"
	});
};

// 下载wgt文件
var wgtUrl = "http://www.i4nova.com/app-update/sjcy/update.wgt";

function downWgt() {
	plus.nativeUI.showWaiting("正在下载", {
		"padlock": true
	});
	plus.downloader.createDownload(wgtUrl, {
		filename: "_doc/update/"
	}, function(d, status) {
		if(status == 200) {
			console.log("下载更新成功：" + d.filename);
			installWgt(d.filename); // 安装wgt资源包
		} else {
			console.log("下载更新失败");
		}
		plus.nativeUI.closeWaiting();
	}).start();
};

// 更新应用资源
function installWgt(path) {
	plus.nativeUI.showWaiting("正在更新", {
		"padlock": true
	});
	plus.runtime.install(path, {}, function() {
		console.log("更新完成");
		// 提示消息
		plus.nativeUI.showWaiting("更新完成", {
			"padlock": true
		});
		// 清空 storage 记录
		plus.storage.clear();
		// 重启
		setTimeout(function() {
			plus.nativeUI.closeWaiting();
			plus.nativeUI.toast("重启应用", {
				"duration": "long"
			});
			plus.runtime.restart();
		}, 1000);
	}, function(e) {
		plus.nativeUI.closeWaiting();
		console.log("更新失败（ " + e.code + " ）：" + e.message);
		plus.runtime.restart();
	});
};