// 全局变量
var Wvs = null,
	Lwv = null,
	Pwv = null,
	Parent = null,
	Children = null,
	// Webview窗口对象的属性
	// 文档 http://www.html5plus.org/doc/zh_cn/webview.html#plus.webview.WebviewObject
	Wv_Style = null,
	Lwv_Style = {
		"scalable": false,
		"scrollIndicator": "none",
		"softinputMode": "adjustPan"
	},
	Pwv_Style = {
		"scalable": false,
		"scrollIndicator": "none",
		"softinputMode": "adjustPan",
		"titleNView": {
			"autoBackButton": true,
			"backgroundColor": "#0F4F5E",
			"coverage": "132px",
			"progress": {
				"color": "#FFFFFF",
				"height": "1px",
			},
			"titleColor": "#FFFFFF",
			"titleText": null,
			"titleSize": "18px",
			"type": "default"
		}
	},
	Scan_Style = {
		"top": "0px",
		"bottom": "20%",
		"scalable": false,
		"scrollIndicator": "none",
		"softinputMode": "adjustPan"
	},
	iPhoneX_Style = {
		"scalable": false,
		"scrollIndicator": "none",
		"softinputMode": "adjustPan",
		"top": "44px"
	},
	urls = [
		// APP 预览和屏幕快照
		"plus/screenshots.html",
		// 种植茶树网址
		"https://www.myteac.com/goods/type/",
		// 我的TEAC网址
		"https://www.myteac.com/member/",
		// 登陆网址
		"https://www.myteac.com/member/login/",
		// 首页网址
		"https://www.myteac.com/"
	],
	Pwv_ID = null,
	Pwv_Url = null,
	Pwv_Number = null;

// 点击按钮，创建新的 Webview 窗口事件处理
// 文档 http://www.html5plus.org/doc/zh_cn/webview.html#plus.webview.create
var footer_height = null;

function createWebview(url, id) {
	// 检查有无操作记录 account 键值
	if(id == "ScreenshotsPage") {
		Pwv_Url = url;
		Pwv_ID = id;
	} else {
		if(plus.storage.getItem("account") == "yes") {
			Pwv_Url = url;
			Pwv_ID = id;
		} else {
			plus.nativeUI.toast("请先登陆或注册", {
				"duration": "long"
			});
			Pwv_Url = urls[3];
			Pwv_ID = "loginPage";
		};
	};
	// 判断变量值与Webview 窗口 ID是否相同，避免快速点击打开多个页面
	if(Pwv_Number == Pwv_ID) {
		return null;
	} else {
		// Webview 窗口 ID 赋值给变量，兼容避免快速点击打开多个页面
		Pwv_Number = Pwv_ID;
	};

	// 检查 Webview 窗口 ID，指定窗口样式
	switch(Pwv_ID) {
		case "ScreenshotsPage":
			Wv_Style = Lwv_Style;
			break;
		case "loginPage":
			Wv_Style = Pwv_Style;
			break;
		case "scanPage":
			Wv_Style = Pwv_Style;
			break;
		case "scanCanvas":
			Wv_Style = Scan_Style;
			break;
		case "dragPage":
			// 获取底部菜单高度
			footer_height = document.querySelector("#footer").offsetHeight + "px";
			Wv_Style = {
				"width": "67%",
				"top": "0px",
				"bottom": footer_height,
				"left": "33%",
				"scalable": false,
				"scrollIndicator": "none",
				"softinputMode": "adjustPan"
			};
			// 开启遮罩
			Lwv.setStyle({
				mask: "rgba(0,0,0,0.4)"
			});
			break;
		default:
			// 获取底部菜单高度
			footer_height = document.querySelector("#footer").offsetHeight + "px";
			Wv_Style = {
				"top": "0px",
				"bottom": footer_height,
				"scalable": false,
				"scrollIndicator": "none",
				"softinputMode": "adjustPan",
				"titleNView": {
					"autoBackButton": true,
					"backgroundColor": "#0F4F5E",
					"buttons": [{
						"color": "#FFFFFF",
						"colorPressed": "#0F4F5E",
						"float": "left",
						//"fontWeight": "bold", // 设置该值会导致iOS端字体显示不正常
						"fontSize": "14px",
						"fontSrc": "_www/fonts/mobirise.ttf", // 扩展相对路径URL(RelativeURL) - 以"_"开头的相对路径
						// 按钮点击后触发的回调函数
						// 仅支持字符串类型，且以 javascript: 为前缀
						// 必须先获得对应的 webview ，然后以 evalJS 的方式执行
						// 目标页面的函数必须是全局函数（通过 window 可访问的的函数）
						"onclick": 'javascript:plus.webview.currentWebview().close();',
						"text": "\ue91a" // 使用字体图标时unicode字符表示必须"\u"开头
					}],
					"coverage": "132px",
					"progress": {
						"color": "#FFFFFF",
						"height": "1px",
					},
					"titleColor": "#FFFFFF",
					"titleText": null,
					"titleSize": "18px",
					"type": "default"
				}
			};
			break;
	};

	// 预创建新窗口
	Pwv = plus.webview.create(
		Pwv_Url,
		Pwv_ID,
		Wv_Style
	);
	console.log("新建窗口 ID：" + Pwv_ID + " / URL：" + Pwv_Url);

	// Webview 窗口滑动事件
	// 文档 http://www.html5plus.org/doc/zh_cn/webview.html#plus.webview.WebviewDragEvent	
	// 检查 Webview 窗口 ID，是否执行窗口滑动事件
	switch(Pwv_ID) {
		case "ScreenshotsPage":
		case "loginPage":
		case "scanCanvas":
			break;
		default:
			Pwv.drag(
				// 窗口手势操作参数
				{
					"direction": "right",
					"moveMode": "followFinger"
				},
				// 手势操作关联对象参数
				{
					"view": Lwv,
					"moveMode": "silent"
				},
				// 滑动操作回调函数
				function(e) {
					// 获取 Webview 窗口滑动事件数据
					// 文档 http://www.html5plus.org/doc/zh_cn/webview.html#plus.webview.WebviewDragEvent
					var dragEvent = JSON.parse(JSON.stringify(e));
					// 监听滑动进度，关闭 Webview 窗口
					if(dragEvent.progress == 100) {
						Pwv.close();
					};
				}
			);
			break;
	};

	// Webview 窗口事件
	// 文档 http://www.html5plus.org/doc/zh_cn/webview.html#plus.webview.WebviewEvent
	var Pwv_TimeOut = null,
		Pwv_Interval = null;
	// Webview 窗口页面开始加载事件
	Pwv.addEventListener("loading", function() {
		// 显示系统等待对话框
		// 文档 http://www.html5plus.org/doc/zh_cn/nativeui.html#plus.nativeUI.showWaiting
		plus.nativeUI.showWaiting("正在加载", {
			"padlock": true
		});

		// Webview 窗口页面加载超时事件
		Pwv_TimeOut = setTimeout(function() {
			console.log("加载超时");
			// 显示自动消失的提示消息
			plus.nativeUI.toast("请检查网络连接是否可用", {
				"duration": "long"
			});
		}, 10000);

		var interval = 0;
		switch(Pwv_ID) {
			case "loginPage":
				Pwv_Interval = setInterval(function() {
					console.log("重复执行检查");
					if(interval === 3) {
						// 关闭重复检查事件
						clearInterval(Pwv_Interval);
					} else {
						interval++;
						if(plus.storage.getItem("account") == "yes") {
							if(plus.webview.getWebviewById("loginPage")) {
								plus.nativeUI.toast("登陆成功", {
									"duration": "long"
								});
								plus.webview.getWebviewById("loginPage").close();
							};
						};
					};
				}, 500);
				break;
			default:
				break;
		};

	});

	// Webview 窗口页面加载完成事件
	Pwv.addEventListener("loaded", function() {
		// 关闭系统等待对话框
		plus.nativeUI.closeWaiting();

		// 关闭 Webview 窗口页面加载超时事件
		clearTimeout(Pwv_TimeOut);
		Pwv_TimeOut = null;

		// 显示 Webview 窗口	
		// 检查 Webview 窗口 ID，指定窗口显示方式
		switch(Pwv_ID) {
			case "ScreenshotsPage":
				Pwv.show("zoom-out", 300);
				break;
			case "loginPage":
				Pwv.show("slide-in-bottom", 300);
				break;
			default:
				Pwv.show("slide-in-right", 300);
				break;
		};

		// 通过键 (key) 检索获取应用存储的值，判断是否首次启动对应的 Webview 窗口
		// 首次启动 Webview 窗口，显示自动消失的提示消息
		switch(Pwv_ID) {
			case "ScreenshotsPage":
			case "loginPage":
			case "scanCanvas":
				break;
			default:
				if(plus.storage.getItem("key_PwvFirstTime") != "yes") {
					// 显示自动消失的提示消息
					plus.nativeUI.toast("向右滑动关闭", {
						"duration": "long"
					});
					// 修改或添加键值(key-value)对数据到应用数据存储中
					plus.storage.setItem("key_PwvFirstTime", "yes");
				};
				break;
		};

		// 获取所有 Webview 窗口事件处理
		// 文档 http://www.html5plus.org/doc/zh_cn/webview.html#plus.webview.all
		Wvs = plus.webview.all();
		for(var i = 0; i < Wvs.length; i++) {
			var Wvs_JSON = JSON.parse(JSON.stringify(Wvs[i]));
			console.log("所有 WebviewObject 窗口对象 ID (JSON)：" + i + " " + Wvs_JSON.id);
		};
	});

	// Webview 窗口关闭事件
	Pwv.addEventListener("close", function() {
		// 关闭 Webview 窗口时，兼容再次打开
		Pwv = null;
		Pwv_Number = null;

		// 判断窗口 ID 字符串，执行指定事件		
		switch(Pwv_ID) {
			case "ScreenshotsPage":
				plus.navigator.setFullscreen(false);
				// 修改或添加键值(key-value)对数据到应用数据存储中
				plus.storage.setItem("key_FirstTime", "no");
				// 刷新首页
				Lwv.reload();
				break;
			case "loginPage":
			case "netPage":
				document.querySelector("#footer .on").className = "";
				document.querySelector("#nav01").className = "on";
				// 重新加载首页
				Embed.loadURL(urls[4]);
				break;
			case "dragPage":
				Lwv.setStyle({
					mask: "none"
				});
				break;
			default:
				break;
		};

		// 获取应用存储区中保存的键值对列表
		var key_Names = [];
		var key_Values = [];
		var key_Number = plus.storage.getLength();
		for(var i = 0; i < key_Number; i++) {
			key_Names[i] = plus.storage.key(i);
			key_Values[i] = plus.storage.getItem(key_Names[i]);
			console.log("获取应用存储区中保存的键值对：" + key_Number + " / key值：" + key_Names[i] + " / 键值：" + key_Values[i]);
		};
	});
};